"""
A thread to handle network concerns
"""

from queues import excQueue  # magic import

import network.asyncore_pollchoose as asyncore
from threads import StoppableThread


class BMNetworkThread(StoppableThread):
    """Main network thread"""
    name = "Asyncore"

    def __init__(self, pool):
        self.pool = pool
        super(BMNetworkThread, self).__init__(self.name)

    def run(self):
        try:
            while not self._stopped and self.pool.state.shutdown == 0:
                self.pool.loop()
        except Exception as e:
            excQueue.put((self.name, e))
            raise

    def stopThread(self):
        super(BMNetworkThread, self).stopThread()
        for i in self.pool.listeningSockets.values():
            try:
                i.close()
            except:
                pass
        for i in self.pool.outboundConnections.values():
            try:
                i.close()
            except:
                pass
        for i in self.pool.inboundConnections.values():
            try:
                i.close()
            except:
                pass

        # just in case
        asyncore.close_all()
